fate: add fate session script
[libav.git] / tests / fate.sh
CommitLineData
a9dc6111
MR
1#! /bin/sh
2
3config=$1
4
5die(){
6 echo "$@"
7 exit 1
8}
9
10test -r "$config" || die "usage: fate.sh <config>"
11
12workdir=$(dirname $config)
13make=make
14
15. "$config"
16
17test -n "$slot" || die "slot not specified"
18test -n "$repo" || die "repo not specified"
19test -d "$samples" || die "samples location not specified"
20
21lock(){
22 lock=$1/fate.lock
23 (set -C; exec >$lock) 2>/dev/null || return
24 trap 'rm $lock' EXIT
25}
26
27checkout(){
28 case "$repo" in
29 file:*|/*) src="${repo#file:}" ;;
30 git:*) git clone "$repo" "$src" ;;
31 svn:*) svn co "$repo" "$src" ;;
32 esac
33}
34
35update()(
36 cd ${src} || return
37 case "$repo" in
38 git:*) git pull ;;
39 svn:*) svn up ;;
40 esac
41)
42
43configure()(
44 cd ${build} || return
45 ${src}/configure \
46 --prefix="${inst}" \
47 --samples="${samples}" \
48 ${arch:+--arch=$arch} \
49 ${cpu:+--cpu="$cpu"} \
50 ${cross_prefix:+--cross-prefix="$cross_prefix"} \
51 ${cc:+--cc="$cc"} \
52 ${target_os:+--target-os="$target_os"} \
53 ${sysroot:+--sysroot="$sysroot"} \
54 ${target_exec:+--target-exec="$target_exec"} \
55 ${target_path:+--target-path="$target_path"} \
56 ${extra_cflags:+--extra-cflags="$extra_cflags"} \
57 ${extra_ldflags:+--extra-ldflags="$extra_ldflags"} \
58 ${extra_libs:+--extra-libs="$extra_libs"} \
59 ${extra_conf}
60)
61
62compile()(
63 cd ${build} || return
64 ${make} ${makeopts} && ${make} install
65)
66
67fate()(
68 cd ${build} || return
69 ${make} ${makeopts} -k fate
70)
71
72report(){
73 date=$(date -u +%Y%m%d%H%M%S)
74 echo "fate:0:${date}:${slot}:${version}:$1:$2" >report
75 cat ${build}/config.fate ${build}/tests/data/fate/*.rep >>report
76 test -n "$fate_recv" && tar cz report *.log | $fate_recv
77}
78
79fail(){
80 report "$@"
81 exit
82}
83
84mkdir -p ${workdir} || die "Error creating ${workdir}"
85lock ${workdir} || die "${workdir} locked"
86cd ${workdir} || die "cd ${workdir} failed"
87
88src=${workdir}/src
89build=${workdir}/build
90inst=${workdir}/install
91report=tests/data/fate/report
92
93test -d "$src" && update || checkout || die "Error fetching source"
94
95cd ${workdir}
96
97version=$(${src}/version.sh ${src})
98test "$version" = "$(cat version 2>/dev/null)" && exit 0
99echo ${version} >version
100
101rm -rf "${build}"
102mkdir -p ${build}
103
104configure >configure.log 2>&1 || fail $? "error configuring"
105compile >compile.log 2>&1 || fail $? "error compiling"
106fate >test.log 2>&1 || fail $? "error testing"
107report 0 success